Index: src/includes/classes/Smarty/sysplugins/smarty_cacheresource.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_cacheresource.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_cacheresource.php	(revision )
@@ -16,20 +16,11 @@
 abstract class Smarty_CacheResource
 {
     /**
-     * cache for Smarty_CacheResource instances
-     *
-     * @var array
-     */
-    public static $resources = array();
-
-    /**
      * resource types provided by the core
      *
      * @var array
      */
-    protected static $sysplugins = array(
-        'file' => true,
-    );
+    protected static $sysplugins = array('file' => 'smarty_internal_cacheresource_file.php',);
 
     /**
      * populate Cached Object with meta data from Resource
@@ -55,10 +46,11 @@
      *
      * @param Smarty_Internal_Template $_template template object
      * @param Smarty_Template_Cached   $cached    cached object
+     * @param bool                     $update    flag if called because cache update
      *
-     * @return boolean true or false if the cached content does not exist
+     * @return bool true or false if the cached content does not exist
      */
-    abstract public function process(Smarty_Internal_Template $_template, Smarty_Template_Cached $cached = null);
+    abstract public function process(Smarty_Internal_Template $_template, Smarty_Template_Cached $cached = null, $update = false);
 
     /**
      * Write the rendered template output to cache
@@ -81,8 +73,8 @@
     {
         if ($_template->cached->handler->process($_template)) {
             ob_start();
-            $_template->properties['unifunc']($_template);
-
+            $unifunc = $_template->cached->unifunc;
+            $unifunc($_template);
             return ob_get_clean();
         }
 
@@ -193,33 +185,25 @@
         }
 
         // try smarty's cache
-        if (isset($smarty->_cacheresource_handlers[$type])) {
-            return $smarty->_cacheresource_handlers[$type];
+        if (isset($smarty->_cache['cacheresource_handlers'][$type])) {
+            return $smarty->_cache['cacheresource_handlers'][$type];
         }
 
         // try registered resource
         if (isset($smarty->registered_cache_resources[$type])) {
             // do not cache these instances as they may vary from instance to instance
-            return $smarty->_cacheresource_handlers[$type] = $smarty->registered_cache_resources[$type];
+            return $smarty->_cache['cacheresource_handlers'][$type] = $smarty->registered_cache_resources[$type];
         }
         // try sysplugins dir
         if (isset(self::$sysplugins[$type])) {
-            if (!isset(self::$resources[$type])) {
-                $cache_resource_class = 'Smarty_Internal_CacheResource_' . ucfirst($type);
+            $cache_resource_class = 'Smarty_Internal_CacheResource_' . ucfirst($type);
-                self::$resources[$type] = new $cache_resource_class();
+            return $smarty->_cache['cacheresource_handlers'][$type] = new $cache_resource_class();
-            }
+        }
-
-            return $smarty->_cacheresource_handlers[$type] = self::$resources[$type];
-        }
         // try plugins dir
         $cache_resource_class = 'Smarty_CacheResource_' . ucfirst($type);
         if ($smarty->loadPlugin($cache_resource_class)) {
-            if (!isset(self::$resources[$type])) {
-                self::$resources[$type] = new $cache_resource_class();
+            return $smarty->_cache['cacheresource_handlers'][$type] = new $cache_resource_class();
-            }
+        }
-
-            return $smarty->_cacheresource_handlers[$type] = self::$resources[$type];
-        }
         // give up
         throw new SmartyException("Unable to load cache resource '{$type}'");
     }
@@ -229,214 +213,11 @@
      *
      * @param Smarty $smarty Smarty object
      */
-    public static function invalidLoadedCache(Smarty $smarty)
+    public function invalidLoadedCache(Smarty $smarty)
     {
-        foreach ($smarty->template_objects as $tpl) {
-            if (isset($tpl->cached)) {
-                $tpl->cached->valid = false;
-                $tpl->cached->processed = false;
+        $smarty->_cache['isCached'] = array();
+        if (isset($smarty->ext->_subtemplate)) {
+            $smarty->ext->_subtemplate->tplObjects = array();
-            }
+        }
-        }
-    }
-}
-
-/**
- * Smarty Resource Data Object
- * Cache Data Container for Template Files
- *
- * @package    Smarty
- * @subpackage TemplateResources
- * @author     Rodney Rehm
- */
-class Smarty_Template_Cached
-{
-    /**
-     * Source Filepath
-     *
-     * @var string
-     */
-    public $filepath = false;
-
-    /**
-     * Source Content
-     *
-     * @var string
-     */
-    public $content = null;
-
-    /**
-     * Source Timestamp
-     *
-     * @var integer
-     */
-    public $timestamp = false;
-
-    /**
-     * Source Existence
-     *
-     * @var boolean
-     */
-    public $exists = false;
-
-    /**
-     * Cache Is Valid
-     *
-     * @var boolean
-     */
-    public $valid = false;
-
-    /**
-     * Cache was processed
-     *
-     * @var boolean
-     */
-    public $processed = false;
-
-    /**
-     * CacheResource Handler
-     *
-     * @var Smarty_CacheResource
-     */
-    public $handler = null;
-
-    /**
-     * Template Compile Id (Smarty_Internal_Template::$compile_id)
-     *
-     * @var string
-     */
-    public $compile_id = null;
-
-    /**
-     * Template Cache Id (Smarty_Internal_Template::$cache_id)
-     *
-     * @var string
-     */
-    public $cache_id = null;
-
-    /**
-     * Id for cache locking
-     *
-     * @var string
-     */
-    public $lock_id = null;
-
-    /**
-     * flag that cache is locked by this instance
-     *
-     * @var bool
-     */
-    public $is_locked = false;
-
-    /**
-     * Source Object
-     *
-     * @var Smarty_Template_Source
-     */
-    public $source = null;
-
-    /**
-     * create Cached Object container
-     *
-     * @param Smarty_Internal_Template $_template template object
-     */
-    public function __construct(Smarty_Internal_Template $_template)
-    {
-        $this->compile_id = $_template->compile_id;
-        $this->cache_id = $_template->cache_id;
-        $this->source = $_template->source;
-        $_template->cached = $this;
-        $smarty = $_template->smarty;
-
-        //
-        // load resource handler
-        //
-        $this->handler = $handler = Smarty_CacheResource::load($smarty); // Note: prone to circular references
-
-        //
-        //    check if cache is valid
-        //
-        if (!($_template->caching == Smarty::CACHING_LIFETIME_CURRENT || $_template->caching == Smarty::CACHING_LIFETIME_SAVED) || $_template->source->recompiled) {
-            $handler->populate($this, $_template);
-
-            return;
-        }
-        while (true) {
-            while (true) {
-                $handler->populate($this, $_template);
-                if ($this->timestamp === false || $smarty->force_compile || $smarty->force_cache) {
-                    $this->valid = false;
-                } else {
-                    $this->valid = true;
-                }
-                if ($this->valid && $_template->caching == Smarty::CACHING_LIFETIME_CURRENT && $_template->cache_lifetime >= 0 && time() > ($this->timestamp + $_template->cache_lifetime)) {
-                    // lifetime expired
-                    $this->valid = false;
-                }
-                if ($this->valid || !$_template->smarty->cache_locking) {
-                    break;
-                }
-                if (!$this->handler->locked($_template->smarty, $this)) {
-                    $this->handler->acquireLock($_template->smarty, $this);
-                    break 2;
-                }
-            }
-            if ($this->valid) {
-                if (!$_template->smarty->cache_locking || $this->handler->locked($_template->smarty, $this) === null) {
-                    // load cache file for the following checks
-                    if ($smarty->debugging) {
-                        Smarty_Internal_Debug::start_cache($_template);
-                    }
-                    if ($handler->process($_template, $this) === false) {
-                        $this->valid = false;
-                    } else {
-                        $this->processed = true;
-                    }
-                    if ($smarty->debugging) {
-                        Smarty_Internal_Debug::end_cache($_template);
-                    }
-                } else {
-                    continue;
-                }
-            } else {
-                return;
-            }
-            if ($this->valid && $_template->caching === Smarty::CACHING_LIFETIME_SAVED && $_template->properties['cache_lifetime'] >= 0 && (time() > ($_template->cached->timestamp + $_template->properties['cache_lifetime']))) {
-                $this->valid = false;
-            }
-            if (!$this->valid && $_template->smarty->cache_locking) {
-                $this->handler->acquireLock($_template->smarty, $this);
-
-                return;
-            } else {
-                return;
-            }
-        }
-    }
-
-    /**
-     * Write this cache object to handler
-     *
-     * @param Smarty_Internal_Template $_template template object
-     * @param string                   $content   content to cache
-     *
-     * @return boolean success
-     */
-    public function write(Smarty_Internal_Template $_template, $content)
-    {
-        if (!$_template->source->recompiled) {
-            if ($this->handler->writeCachedContent($_template, $content)) {
-                $this->content = null;
-                $this->timestamp = time();
-                $this->exists = true;
-                $this->valid = true;
-                if ($_template->smarty->cache_locking) {
-                    $this->handler->releaseLock($_template->smarty, $this);
-                }
-
-                return true;
-            }
-        }
-
-        return false;
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_getregisteredobject.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_getregisteredobject.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_getregisteredobject.php	(revision )
@@ -0,0 +1,44 @@
+<?php
+
+/**
+ * Smarty Method GetRegisteredObject
+ *
+ * Smarty::getRegisteredObject() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_GetRegisteredObject
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * return a reference to a registered object
+     *
+     * @api  Smarty::getRegisteredObject()
+     * @link http://www.smarty.net/docs/en/api.get.registered.object.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $object_name object name
+     *
+     * @return object
+     * @throws \SmartyException if no such object is found
+     */
+    public function getRegisteredObject(Smarty_Internal_TemplateBase $obj, $object_name)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if (!isset($smarty->registered_objects[$object_name])) {
+            throw new SmartyException("'$object_name' is not a registered object");
+        }
+        if (!is_object($smarty->registered_objects[$object_name][0])) {
+            throw new SmartyException("registered '$object_name' is not an object");
+        }
+        return $smarty->registered_objects[$object_name][0];
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_gettags.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_gettags.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_gettags.php	(revision )
@@ -0,0 +1,62 @@
+<?php
+
+/**
+ * Smarty Method GetTags
+ *
+ * Smarty::getTags() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_GetTags
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Return array of tag/attributes of all tags used by an template
+     *
+     * @api  Smarty::getTags()
+     * @link http://www.smarty.net/docs/en/api.get.tags.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param null|string|Smarty_Internal_Template                            $template
+     *
+     * @return array of tag/attributes
+     * @throws \SmartyException
+     */
+    public function getTags(Smarty_Internal_TemplateBase $obj, $template = null)
+    {
+        /* @var Smarty $smarty */
+        $smarty = isset($this->smarty) ? $this->smarty : $obj;
+        if ($obj->_objType == 2 && !isset($template)) {
+            $tpl = clone $obj;
+        } elseif (isset($template) && $template->_objType == 2) {
+            $tpl = clone $template;
+        } elseif (isset($template) && is_string($template)) {
+            /* @var Smarty_Internal_Template $tpl */
+            $tpl = new $smarty->template_class($template, $smarty);
+            // checks if template exists
+            if (!$tpl->source->exists) {
+                throw new SmartyException("Unable to load template {$tpl->source->type} '{$tpl->source->name}'");
+            }
+        }
+        if (isset($tpl)) {
+            $tpl->smarty = clone $tpl->smarty;
+            $tpl->smarty->_cache['get_used_tags'] = true;
+            $tpl->_cache['used_tags'] = array();
+            $tpl->smarty->merge_compiled_includes = false;
+            $tpl->smarty->disableSecurity();
+            $tpl->caching = false;
+            $tpl->loadCompiler();
+            $tpl->compiler->compileTemplate($tpl);
+            return $tpl->_cache['used_tags'];
+        }
+        throw new SmartyException("Missing template specification");
+    }
+}
\ No newline at end of file
